/*
 *   Copyright (C) 2012 Yury P. Fedorchenko
 *   yuryfdr@users.sf.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
#ifndef __checkers_not_h__
#define __checkers_not_h__

#include <vector>
#include <iostream>

struct chmove {
  int from;
  int to;
  struct pos{
    int pos;
    int type;
  };
  std::vector<pos> path;
  bool capt;
  bool res;
};
struct chgame {
  static const char* RNOTATION;// "b8d8f8h8a7c7e7g7b6d6f6h6a5c5e5g5b4d4f4h4a3c3e3g3b2d2f2h2a1c1e1g1"
  std::string rn;
  std::string event;
  std::string site;
  std::string date;
  int round;
  int gametype;
  std::string white;
  std::string black;
  std::string result;
  std::vector<chmove> moves;
  bool is_white;
  bool loaded;
  chgame():is_white(true),loaded(false){
    rn=RNOTATION;
    gametype=25;
  }
  chgame(const std::string&dt,int rnd,int gmtype):event("?"),site("?"),date(dt),round(rnd),
        gametype(gmtype),loaded(false){
    rn=RNOTATION;
  }
  void addMove(const chmove& mv){
    moves.push_back(mv);
  }
  inline std::ostream& writeMove(std::ostream& o,const chmove& mv) const;
};

#endif

